#========================================================================================
# package      DE_EPAGES::Amazon::t::GetFeedSubmissionListResponseHandlerTest
# base         Test::Class
# state        private
#----------------------------------------------------------------------------------------
# description  Tests for GetFeedSubmissionListResponseHandler
#========================================================================================
package DE_EPAGES::Amazon::t::GetFeedSubmissionListResponseHandlerTest;
use base Test::Class;

use DE_EPAGES::Amazon::API::MWS::GetFeedSubmissionListResponseHandler;
use DE_EPAGES::Core::API::Error qw ( ExistsError GetError );
use Test::More;
use strict;

# setup methods are run before every test method.
sub setUp : Test(setup) {
    my $self = shift;
    $self->{Handler} = DE_EPAGES::Amazon::API::MWS::GetFeedSubmissionListResponseHandler->new();
}

sub handleSubmissionResultDocument : Test {
    my $self = shift;
    my $xml  = <<'EOL';
<?xml version="1.0"?>
<GetFeedSubmissionListResponse xmlns="http://mws.amazonaws.com/doc/2009-01-01/">
<GetFeedSubmissionListResult><NextToken></NextToken>
<HasNext>false</HasNext>
<FeedSubmissionInfo><FeedSubmissionId>2529194756</FeedSubmissionId>
<FeedType>_POST_OFFER_ONLY_DATA_</FeedType>
<SubmittedDate>2012-01-02T16:19:07+00:00</SubmittedDate>
<FeedProcessingStatus>_DONE_</FeedProcessingStatus>
<StartedProcessingDate>2012-01-02T16:19:36+00:00</StartedProcessingDate>
<CompletedProcessingDate>2012-01-02T16:20:04+00:00</CompletedProcessingDate>
</FeedSubmissionInfo></GetFeedSubmissionListResult><ResponseMetadata>
<RequestId>916e7a00-ad9e-4d95-a594-9c4ab044c990</RequestId>
</ResponseMetadata></GetFeedSubmissionListResponse>
EOL
    $self->{Handler}->handle($xml);
    is_deeply( $self->{Handler}->Result(), { DocumentProcessingStatus => '_DONE_', 'DocumentID' => '2529194756', }, 'extracted feed submission info' );
}

package main;    ## no critic (ProhibitMultiplePackages)
use DE_EPAGES::Core::API::Script qw ( RunScript );

RunScript(
    Sub => sub {
        Test::Class->runtests;
    }
);

1;
