#========================================================================================
# package      DE_EPAGES::Amazon::t::GetReportListResponseHandlerTest
# base         Test::Class
# state        private
#----------------------------------------------------------------------------------------
# description  Tests for GetReportListResponseHandler
#========================================================================================
package DE_EPAGES::Amazon::t::GetReportListResponseHandlerTest;
use base Test::Class;

use DE_EPAGES::Amazon::API::MWS::GetReportListResponseHandler;
use DE_EPAGES::Core::API::Error qw ( ExistsError GetError );
use Test::More;
use strict;

# setup methods are run before every test method.
sub setUp : Test(setup) {
    my $self = shift;
    $self->{Handler} = DE_EPAGES::Amazon::API::MWS::GetReportListResponseHandler->new();
}

sub handleReportListResponse : Test(2) {
    my $self = shift;
    my $xml = <<'EOL';
<?xml version="1.0"?>
<GetReportListResponse xmlns="http://mws.amazonaws.com/doc/2009-01-01/">
  <GetReportListResult>
  <NextToken>2YgYW55IPQhvu5hbCBwbGVhc3VyZS4=</NextToken>
    <HasNext>true</HasNext>
    <ReportInfo>
      <ReportId>898899473</ReportId>
      <ReportType>_GET_MERCHANT_LISTINGS_DATA_</ReportType>
      <ReportRequestId>2278662938</ReportRequestId>
      <AvailableDate>2009-02-10T09:22:33+00:00</AvailableDate>
      <Acknowledged>false</Acknowledged>
    </ReportInfo>
  </GetReportListResult>
  <ResponseMetadata>
    <RequestId>fbf677c1-dcee-4110-bc88-2ba3702e331b</RequestId>
  </ResponseMetadata>
</GetReportListResponse>
EOL

    $self->{Handler}->handle($xml);
    is_deeply($self->{Handler}->Result(), [ '898899473' ], 'report id');
    is($self->{Handler}->nextToken(), '2YgYW55IPQhvu5hbCBwbGVhc3VyZS4=', 'next token');
}

package main;                                                                     ## no critic (ProhibitMultiplePackages)
use DE_EPAGES::Core::API::Script qw ( RunScript );

RunScript(
    Sub => sub {
        Test::Class->runtests;
    }
);

1;

__DATA__

