#========================================================================================
# package      DE_EPAGES::Amazon::t::MWSResponseHandlerTest
# base         Test::Class
# state        private
#----------------------------------------------------------------------------------------
# description  Tests for MWSResponseHandler
#========================================================================================
package DE_EPAGES::Amazon::t::MWSResponseHandlerTest;
use base Test::Class;

use strict;

use DE_EPAGES::Amazon::API::MWS::MWSResponseHandler;
use DE_EPAGES::Core::API::Error qw ( ExistsError GetError );
use Test::More;
use strict;

sub testWithIdentifier : Test {
    my $self = shift;
    my $xml = <<'EOL';
<?xml version="1.0"?>
<Xml><A/></Xml>
EOL
    my $Handler = DE_EPAGES::Amazon::API::MWS::MWSResponseHandler->new(identifier => '1234');
    $Handler->handle($xml);
    is($Handler->identifier, '1234', 'identifier');
}

sub testPlain : Test {
    my $self = shift;
    my $xml = <<'EOL';
<?xml version="1.0"?>
<Xml><A/></Xml>
EOL
    my $Handler = DE_EPAGES::Amazon::API::MWS::MWSResponseHandler->handle($xml);
    is($Handler->Result(), $xml, 'plain xml in result.');
}

package main;                                                                     ## no critic (ProhibitMultiplePackages)
use DE_EPAGES::Core::API::Script qw ( RunScript );

RunScript(
    Sub => sub {
        Test::Class->runtests;
    }
);

1;