#========================================================================================
# package      DE_EPAGES::Amazon::t::ManageReportScheduleResponseHandlerTest
# base         Test::Class
# state        private
#----------------------------------------------------------------------------------------
# description  Tests for ManageReportScheduleResponseHandler
#========================================================================================
package DE_EPAGES::Amazon::t::ManageReportScheduleResponseHandlerTest;
use base Test::Class;

use strict;

use DE_EPAGES::Amazon::API::MWS::ManageReportScheduleResponseHandler;
use DE_EPAGES::Core::API::Error qw ( ExistsError GetError );
use Test::More;
use strict;

# setup methods are run before every test method.
sub setUp : Test(setup) {
    my $self = shift;
    $self->{Handler} = DE_EPAGES::Amazon::API::MWS::ManageReportScheduleResponseHandler->new();
}

sub handleError : Test {
    my $self = shift;
    my $xml = <<'EOL';
<?xml version="1.0"?>
<ErrorResponse xmlns="http://mws.amazonaws.com/doc/2009-01-01/">
<Error>
  <Type>Sender</Type>
  <Code>InvalidRequest</Code>
  <Message>parameter ReportType failed a validation check: value cannot be empty.</Message>
  <Detail/>
</Error>
<RequestID>faaf7f6d-291d-4120-b630-4a418955c825</RequestID>
</ErrorResponse>
EOL
    eval {
        $self->{Handler}->handle($xml);
        fail('should throw exception.');
    };
    if (ExistsError()) {
        my $Error = GetError();
        is($Error->code, 'InvalidRequest', 'Caught InvalidRequest exception.');
    }
}

package main;                                                                     ## no critic (ProhibitMultiplePackages)
use DE_EPAGES::Core::API::Script qw ( RunScript );

RunScript(
    Sub => sub {
        Test::Class->runtests;
    }
);

1;