
dojo.provide('epages.cartridges.de_epages.externalcontent.twitterfollowme');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.TwitterFollowMe = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.TwitterFollowMe,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.TwitterFollowMe',
	title           : 'Twitter Follow Me',

	TwitterName     : '',
	ButtonColor			: 'a', // a = blue, b = white, c = black
	ButtonVariation : 0, // Number in List
	ButtonVariationName : 'follow_me', // Name of the corresponding Number
	own_button_input : '', // link to own followMe-image

	width           : 150,
	height          : 60,
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_twitterfollowme.png',
	imgsrc			: epages.vars.StoreRoot + '/SF/SocialWeb/',
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			TwitterName : this.TwitterName,
			ButtonColor : this.ButtonColor,
			ButtonVariation : this.ButtonVariation,
			ButtonVariationName : this.ButtonVariationName,
			own_button_input : this.own_button_input
		});
		return info;
	},

	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		this.TwitterName = this.formData.get('TwitterName')[0];

			this.ButtonColor = this.formData._data["ButtonColor"];

			if(this.formData.get('ButtonVariation')[0] != ''){
				this.ButtonVariation = 0;
				this.ButtonVariationName = 'follow_me';
			}
			else if(this.formData.get('ButtonVariation')[1] != ''){
				this.ButtonVariation = 1;
				this.ButtonVariationName = 'follow_bird';
			}
			else if(this.formData.get('ButtonVariation')[2] != ''){
				this.ButtonVariation = 2;
				this.ButtonVariationName = 'twitter';
			}
			else if(this.formData.get('ButtonVariation')[3] != ''){
				this.ButtonVariation = 3;
				this.ButtonVariationName = 't_logo';
			}
			else if(this.formData.get('ButtonVariation')[4] != ''){
				this.ButtonVariation = 4;
				this.ButtonVariationName = 't_small';
			}
			else if(this.formData.get('ButtonVariation')[5] != ''){
				this.ButtonVariation = 5;
				this.ButtonVariationName = 't_mini';
			}
			else if(this.formData.get('ButtonVariation')[6] != ''){
				this.own_button_input = this.formData.get('own_button_input')[0];
			}
	},

	contentString: function (info, ispreview) {
			if(info.TwitterName.length == 0){
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('TwitterFollowMeError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				var retString = "",
					imgClass = "",
					imgSrc = "data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7";
							
				if( ispreview ){
					imgSrc = (this.formData.get('ButtonVariation')[6] == '' ? (this.imgsrc + info.ButtonVariationName + '-' + info.ButtonColor +'.png') : this.own_button_input);
				}
				else if( this.formData.get('ButtonVariation')[6] == '' ){
					imgClass = "ep-metaparse .attr('src',ep.config.storeTypeRoot+'/SF/SocialWeb/" + info.ButtonVariationName + "-" + info.ButtonColor + ".png')"
				}
				else{
					imgSrc = this.own_button_input;
				}

				retString = ''
						+ '<a href="http://www.twitter.com/' + info.TwitterName + '" target="_blank">'
						+ '<img class="' + imgClass + '" src="' + imgSrc + '" />'
						+ '</a>';
							
				return retString;
			}

	},
	
	mceInsertContent: function(info){
		if (info === undefined) var info = this.info();
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});