use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::TrustedShops::API::RemoteTrustedShops;

use Test::More;

sub Main {
    testResultItemsToArray();
    done_testing();
}

sub testResultItemsToArray {
    ## no critic (ProtectPrivateSubs) 
    my $hTest->{'item'} = undef;
    is_deeply(DE_EPAGES::TrustedShops::API::RemoteTrustedShops::_ResultItemsToArray($hTest), [$hTest->{item}], 'undef returns an empty list');
    $hTest->{'item'} = {
            eins => 'eins',
    };
    is_deeply(DE_EPAGES::TrustedShops::API::RemoteTrustedShops::_ResultItemsToArray($hTest), [$hTest->{item}], 'returns an Array with a one element list');
    $hTest->{'item'} = [
        {eins => 'eins'},
        {zwei => 'zwei'}
    ];
    is_deeply(DE_EPAGES::TrustedShops::API::RemoteTrustedShops::_ResultItemsToArray($hTest), $hTest->{item}, 'returns an Array with a multi element list');
}

RunScript( Sub => \&Main );
