/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.rssreader $Revision: 1.34.18.1 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.rssreader');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.template');
dojo.require('epages.io.translation');
epages.cartridges.de_epages.externalcontent.RSSReader = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.RSSReader,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass      : 'epages.cartridges.de_epages.externalcontent.RSSReader',
	preview           : epages.vars.StoreRoot + '/BO/icons/navelement_rssreader.png',
	title             : 'RSSReader',
	width             : "100%",
	height            : 100,
	icon              : epages.vars.StoreRoot + '/SF/Gadgets/rss-icon.png',
	doInsertDom       : false,
	directPreview     : false,

	url               : '',
  feed              : '',
  version           : '',
  feedname          : '',
  feeddescription   : '',
  pagelink          : '',
  news              : Array(),
  error             : '',
  errormsg          : '',
  length            : 5,
  textlength        : 1,//1 fr unbeschrnkte Textlnge da -1 zu Problemen fhrte
  lengthrequest     : 50,
  logolink          : '',
  logosrc           : '',
  logotitle         : '',
  feedPubDate       : '',
  striphtml         : false,
  showlogo          : false,
  stripimages       : false,
  onlyheadlines     : false,
  style             : 'classic',
  isindividual      : false,
  translation       : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),
  _readerid         : null,
  _info             : null,

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			url            : this.url,
			length         : this.length,
			textlength     : this.textlength,
			showlogo       : this.showlogo,
			stripimages    : this.stripimages,
			onlyheadlines  : this.onlyheadlines,
			style          : this.style
		});
		return info;
	},
	boxTemplateString:
			'<div class="(%Class%)">\n'
		 +'  <div class="BoxContainer">\n'
		 +'    <div class="ContextBoxHead">\n'
		 +'      <span><img src="(%RSSIcon%)" onclick="RSSReader[(%RSSId%)].refresh();" title="(%RefreshFeed%)" class="AlignMiddle RSSIcon LinkImage RightPaddingSmall" />&nbsp;<a href="(%FeedLink%)" target="_blank">(%FeedName%)</a></span>\n'
		 +'    </div>\n'
		 +'    <div class="(%CaptionClass%)">\n'
		 +'      (%FeedPubDate%)(%FeedDescription%) (%Logo%)\n'
		 +'    </div>\n'
		 +'    (%INC-Items%)\n'
		 +'  </div>\n'
		 +'</div>\n',
	boxItemTemplateString:
			'<div class="(%Class%)">\n'
		 +'  <a target="_blank" href="(%URL%)">(%Title%)</a><br />\n'
		 +'  (%PubDate%)(%Text%)\n'
		 +'</div>\n',
	classicTemplateString:
			'<div class="(%Class%)">\n'
		 +' <div class="(%HeadClass%)">'
		 +'		<div style="float:right;">(%Logo%)</div>\n'
		 +'			<div class="(%FeedNameClass%)">'
		 +'			<img src="(%RSSIcon%)" onclick="RSSReader[(%RSSId%)].refresh();" title="(%RefreshFeed%)" align="left" class="AlignMiddle RSSIcon LinkImage" />'
		 +'			<a href="(%FeedLink%)" target="_blank">(%FeedName%)</a>'
		 +'			</div>'
		 +'		(%FeedPubDate%)(%FeedDescription%)'
		 +' </div>'
		 +' <div style="clear:both;">\n'
		 +' 	(%INC-Items%)\n'
		 +'	</div>\n'
		 +'</div>\n',
	classicItemTemplateString:
			'<div class="(%HeadlineClass%)">\n'
		 +'  <a target="_blank" href="(%URL%)">(%Title%)</a><br />\n'
		 +'</div>\n'
		 +'<div class="(%TextClass%)">\n'
		 +'  (%PubDate%)(%Text%)\n'
		 +'</div>\n',
	standardTemplateString:
			'<div>\n'
		 +' <div>'
		 +'		<div style="float:right;">(%Logo%)</div>\n'
		 +'			<div>'
		 +'			<img src="(%RSSIcon%)" class="LinkImage" onclick="RSSReader[(%RSSId%)].refresh();" title="(%RefreshFeed%)" align="left" />'
		 +'			<a href="(%FeedLink%)" target="_blank">(%FeedName%)</a>'
		 +'			</div>'
		 +'		(%FeedPubDate%)(%FeedDescription%)'
		 +' </div>'
		 +' <div style="clear:both;">\n'
		 +' 	(%INC-Items%)\n'
		 +'	</div>\n'
		 +'</div>\n',
	standardItemTemplateString:
			'<div>\n'
		 +'  <a target="_blank" href="(%URL%)">(%Title%)</a><br />\n'
		 +'</div>\n'
		 +'<div>\n'
		 +'  (%PubDate%)(%Text%)\n'
		 +'</div>\n',
	getData: function(url,lengthrequest){
    this.error = false;
    this.url = decodeURIComponent(url);
    this.makeRequest();
    if(this.error == false){
      this.readResponse();
    }
    else{
    	return false;
    }
  },
  makeRequest:function(){
    dojo.xhrGet({
      url:'/WebRoot/RssFeeds/'+this.url.replace(/[^A-Za-z0-9]/g,"_")+'.xml',
      load: dojo.hitch(this, 'useResponse'),
      error: dojo.hitch(this, 'secondRequest'),
      handleAs: "xml",
      sync:true
    });
  },
  secondRequest: function(type, error){
		dojo.xhrGet({
      url:'?ObjectID='+epages.vars.SiteID+'&ChangeAction=GetFeed&feedurl='+encodeURIComponent(this.url),
      load: dojo.hitch(this, 'useResponse'),
      error: dojo.hitch(this, 'errorHandler'),
      handleAs: "xml",
      sync:true
    });
  },
  errorHandler:function(response, ioArgs){
  	this.error = true;
  	this.errormsg = this.translation.get('FeedNotAvailable');
  },
  useResponse: function(response, ioArgs){
    this.feed = response;
  },
  readResponse: function(){
    //Version ermitteln
    this.version ='';
    var itemname;
    var subtitle;
    var content;
    if(this.feed && this.feed.getElementsByTagName('rss')[0]!=null || this.feed && this.feed.firstChild.tagName == 'rss'){
      this.version = 'RSS';
      itemname = 'item';
      subtitle = 'description';
      content = 'description';
    }
    else if(this.feed && this.feed.getElementsByTagName('feed')[0]!=null || this.feed && this.feed.firstChild.tagName == 'feed'){
      this.version = 'ATOM';
      itemname = 'entry';
      subtitle = 'subtitle';
      content = 'summary';
    }
    else if(this.feed && this.feed.getElementsByTagName('rdf:RDF')[0]!=null || this.feed && this.feed.firstChild.tagName == 'rdf:RDF'){
      this.version = 'RDF';
      itemname = 'item';
      subtitle = 'description';
      content = 'description';
    }
    else{
      this.error = true;
      this.errormsg = this.translation.get('UnableToDetectFeedVersion');
      return false;
    }
    //Bezeichnung des Feeds ermitteln
    this.feedname ='';
    this.feedname = this.feed.getElementsByTagName('title')[0].firstChild.nodeValue;
    //falls vorhanden Untertitel des Feeds ermitteln
    this.feeddescription="";
    if(this.feed.getElementsByTagName(subtitle)[0] && this.feed.getElementsByTagName(subtitle)[0].firstChild){
      this.feeddescription = this.feed.getElementsByTagName(subtitle)[0].firstChild.nodeValue;
    }
    //zweite Mglichkeit fr Untertitel mit anderem Schlsselwort
    else if(this.feed.getElementsByTagName('tagline')[0] && this.feed.getElementsByTagName('tagline')[0].firstChild){
      this.feeddescription = this.feed.getElementsByTagName('tagline')[0].firstChild.nodeValue;
    }
    //Link zur Anbieterseite des Feeds ermitteln
    this.pagelink ='';
    if(this.version == 'ATOM'){
      var links = this.feed.getElementsByTagName('link');
        for( var i=0,l=links.length ; i<l ; i++ ){
          if(links[i].attributes.getNamedItem('rel') && links[i].attributes.getNamedItem('rel').value=='alternate'){
            this.pagelink = links[i].attributes.getNamedItem('href').value;
            break;
          }
        }
        if(this.pagelink == ''){
					if(this.feed.getElementsByTagName('link')[0] && this.feed.getElementsByTagName('link')[0].attributes.getNamedItem('href')){
						this.pagelink = this.feed.getElementsByTagName('link')[0].attributes.getNamedItem('href').value;
					}
        }
    }
    else{
    	if(this.feed.getElementsByTagName('link')){
    		if(this.feed.getElementsByTagName('link')[0].firstChild){
      		this.pagelink = this.feed.getElementsByTagName('link')[0].firstChild.nodeValue;
      	}else{
      		this.pagelink = this.feed.getElementsByTagName('link')[0].attributes.getNamedItem('href').value;
      	}
    	}
    }
    //falls vorhanden Logo ermitteln
    this.logosrc = '';
    this.logolink = '';
    this.logotitle = '';
    if(this.version == 'RSS'){
    	if(this.feed.getElementsByTagName('image')[0] && this.feed.getElementsByTagName('image')[0].getElementsByTagName('url')[0]){
    		// checken ob tag leer ist!
    		if(this.feed.getElementsByTagName('image')[0].getElementsByTagName('url')[0].firstChild){
    			this.logosrc = this.feed.getElementsByTagName('image')[0].getElementsByTagName('url')[0].firstChild.nodeValue;
    		}
    	}
    	if(this.feed.getElementsByTagName('image')[0] && this.feed.getElementsByTagName('image')[0].getElementsByTagName('title')[0]){
    		if(this.feed.getElementsByTagName('image')[0].getElementsByTagName('title')[0].firstChild){
    			this.logotitle = this.feed.getElementsByTagName('image')[0].getElementsByTagName('title')[0].firstChild.nodeValue;
    		}
    	}
    	if(this.feed.getElementsByTagName('image')[0] && this.feed.getElementsByTagName('image')[0].getElementsByTagName('link')[0]){
    		if(this.feed.getElementsByTagName('image')[0].getElementsByTagName('link')[0].firstChild){
    			this.logolink = this.feed.getElementsByTagName('image')[0].getElementsByTagName('link')[0].firstChild.nodeValue;
    		}
    	}
  	}
  	if(this.version == 'RDF'){
  		if(this.feed.getElementsByTagName('image')[0]){
				this.logosrc = this.feed.getElementsByTagName('image')[0].attributes[0].value;
				this.logolink = this.pagelink;
				this.logotitle = this.feedname;
  		}
  	}
  	if(this.version == 'ATOM'){
  		if(this.feed.getElementsByTagName('logo')[0]){
				this.logosrc = this.feed.getElementsByTagName('logo')[0].firstChild.nodeValue;
				this.logolink = this.pagelink;
				this.logotitle = this.feedname;
  		}
  		else if(this.feed.getElementsByTagName('icon')[0]){
  			this.logosrc = this.feed.getElementsByTagName('icon')[0].firstChild.nodeValue;
				this.logolink = this.pagelink;
				this.logotitle = this.feedname;
  		}
  	}

  	//falls vorhanden Datum des Feeds ermitteln
  	this.feedPubDate = '';
  	if(this.feed.getElementsByTagName('pubDate')[0]){
    		var pubDate = this.feed.getElementsByTagName('pubDate')[0].firstChild.nodeValue;
    		pubDate = new Date(pubDate);
    		if(pubDate && pubDate != 'Invalid Date'){
    			this.feedPubDate = pubDate.toLocaleString();
    		}
    	}
    //Nachrichten auslesen
    this.news = new Array();
    var items = this.feed.getElementsByTagName(itemname);
    for( var i=0,l=items.length ; i<l ; i++ ){
    	var item = new Object();
    	//Titel der Nachricht ermitteln
      if(items[i].getElementsByTagName('title')[0] && items[i].getElementsByTagName('title')[0].firstChild){
      	item['title'] = items[i].getElementsByTagName('title')[0].firstChild.nodeValue;


      //Link zur Nachricht ermitteln
    	if(this.version == "ATOM"){
      	var itemlinks = items[i].getElementsByTagName('link');
      	for( var j=0,jLength=itemlinks.length ; j<jLength ; j++ ){
        	if(itemlinks[j].attributes.getNamedItem('href')){
          	item['link'] = itemlinks[j].attributes.getNamedItem('href').value;
        	}
        	if(itemlinks[j].attributes.getNamedItem('rel') && itemlinks[j].attributes.getNamedItem('rel').value == 'alternate'){
        		item['link'] = itemlinks[j].attributes.getNamedItem('href').value;
        		j = itemlinks.length+1;
        	}
      	}
    	}
    	else{
      	if(items[i].getElementsByTagName('link')[0] && items[i].getElementsByTagName('link')[0].firstChild){
      		item['link'] = items[i].getElementsByTagName('link')[0].firstChild.nodeValue;
      	}
      	else{
      		item['link'] = this.pagelink;
      	}
    	}
    	//Inhalt der Nachricht ermitteln
    	if(items[i].getElementsByTagName(content)[0] && items[i].getElementsByTagName(content)[0].firstChild){
      	item['text'] = items[i].getElementsByTagName(content)[0].firstChild.nodeValue;
      	if(this.striphtml == "on"){
        	//HTML Tags aus Text entfernen
        	item['text'] = item['text'].replace(/\<.*?\>/gi, "");
      	}
    	}
    	//zweite Mglichkeit fr Atom mit anderem Schlsselwort
    	else if(items[i].getElementsByTagName('content')[0] && items[i].getElementsByTagName('content')[0].firstChild){
      	item['text'] = items[i].getElementsByTagName('content')[0].firstChild.nodeValue;
      	if(this.striphtml == "on"){
        	//HTML Tags aus Text entfernen
        	item['text'] = item['text'].replace(/\<.*?\>/gi, "");
      	}
    	}
    	else if(items[i].getElementsByTagName('content:encoded')[0] && items[i].getElementsByTagName('content:encoded')[0].firstChild){
      	item['text'] = items[i].getElementsByTagName('content:encoded')[0].firstChild.nodeValue;
      	if(this.striphtml == "on"){
        	//HTML Tags aus Text entfernen
        	item['text'] = item['text'].replace(/\<.*?\>/gi, "");
      	}
    	}
    	else{
    		item['text'] = "";
    	}
    	//wenn vorhanden Veroeffentlichungsdatum auslesen
    	item['pubDate']= "";
  		if(items[i].getElementsByTagName('pubDate')[0]){
    		var pubDate = items[i].getElementsByTagName('pubDate')[0].firstChild.nodeValue;
    		pubDate = new Date(pubDate);
    		if(pubDate && pubDate != 'Invalid Date'){
    			item['pubDate'] = pubDate.toLocaleString();
    		}
    	}
    	this.news.push(item);
      }
    }
  },
	showData: function(style,length,textlength,showlogo,stripimages,onlyheadlines,id){
		this._readerid = id;
		if(this.error == true){
			dojo.publish('OnDisableSaveButton',[{id:this.id}]);
			return this.errormsg;
		}
		else{
			if(length > this.news.length){
      	length = this.news.length;
    	}
			this.length = length;
			this.textlength = textlength;
			if(onlyheadlines == "on"){
				this.textlength = 0;
			}
			this.showlogo = showlogo;
			this.stripimages = stripimages;
			var returnstring;
			switch (style){
				case 'standard':
					returnstring = this.createStandard();
					break;
				case 'classic':
					returnstring = this.createClassic();
					break;
				case 'box':
					returnstring = this.createBox();
					break;
				default:
				  this.error = true;
				  this.errormsg = "Fehler: ungltige Styleangabe";
					return this.errormsg;
				break;
			}
	}
		return returnstring;
	},
	createBox: function(){
		var logo = '';
		if(this.showlogo == "on" && this.logosrc != ''){
			logo = '<a href="'+this.logolink+'" target="_blank"><img src="'+this.logosrc+'"></a>';
		}
		var items = '';
		for( var i=0,iLength=this.length ; i<iLength ; i++ ){
			var text = this.news[i]["text"];
			if(this.textlength > 1){
          text = text.substr(0,this.textlength);
          var lastspace = text.lastIndexOf(" ");
          text = text.substr(0,lastspace);
          text += "...";
        }
        else if(this.textlength == 0){
        	text = "";
        }
        if(this.stripimages == "on"){
        	text = text.replace(/\<img.*?\>/gi,"");
        }
      var pubDate = this.news[i]["pubDate"] != '' &&  this.textlength != 0 ? this.news[i]["pubDate"]+'<br />': '';
			var templateProcessorItems = new epages.Template({
				template    : this.boxItemTemplateString,
				encodeVars  : false,
				vars        : {
					'Class'     : 'ContextBoxBody',
					'URL'       : this.news[i]["link"],
					'Title'     : this.news[i]["title"],
					'Text'      : text,
					'PubDate'   : pubDate
				}
			});
			items += templateProcessorItems.generateOutput();
		}
		var templateProcessor = new epages.Template({
			template    : this.boxTemplateString,
			encodeVars  : false,
			vars        : {
				'Class'            : 'ContextBox',
				'CaptionClass'     : 'ContextBoxBody',
				'RSSIcon'          : this.icon,
				'FeedLink'         : this.pagelink,
				'FeedName'         : this.feedname,
				'FeedDescription'  : this.feeddescription,
				'FeedPubDate'      : this.feedPubDate != '' ? this.feedPubDate+'<br />': '',
				'Logo'             : logo,
				'INC-Items'        : items,
				'RSSId'            : this._readerid,
				'RefreshFeed'      : this.translation.get('RefreshFeed')
			}
		});
		 var output = templateProcessor.generateOutput();
		 return output;
	},
	createClassic: function(){
		var logo = '';
		if(this.showlogo == "on" && this.logosrc != ''){
			logo = '<a href="'+this.logolink+'" target="_blank"><img src="'+this.logosrc+'" /></a>';
		}
		var items = '';
		for( var i=0,iLength=this.length ; i<iLength ; i++ ){
			var text = this.news[i]["text"];
			if(this.textlength > 1){
          text = text.substr(0,this.textlength);
          var lastspace = text.lastIndexOf(" ");
          text = text.substr(0,lastspace);
          text += "...";
        }
        else if(this.textlength == 0){
        	text = "";
        }
        if(this.stripimages == "on"){
        	text = text.replace(/\<img.*?\>/gi,"");
        }
      var pubDate = this.news[i]["pubDate"] != '' &&  this.textlength != 0 ? this.news[i]["pubDate"]+'<br />': '';
			var templateProcessorItems = new epages.Template({
				template    : this.classicItemTemplateString,
				encodeVars  : false,
				vars        : {
					'HeadlineClass'  : 'PostHeadlineColumn',
					'TextClass'      : 'PostText',
					'URL'            : this.news[i]["link"],
					'Title'          : this.news[i]["title"],
					'Text'           : text,
					'PubDate'        : pubDate
				}
			});
			items += templateProcessorItems.generateOutput();
		}
		var templateProcessor = new epages.Template({
			template    : this.classicTemplateString,
			encodeVars  : false,
			vars        : {
				'Class'            : 'RSSFeed Classic',
				'HeadClass'        : 'Head',
				'FeedNameClass'    : 'FeedName',
				'RSSIcon'          : this.icon,
				'FeedLink'         : this.pagelink,
				'FeedName'         : this.feedname,
				'FeedDescription'  : this.feeddescription,
				'FeedPubDate'      : this.feedPubDate != '' ? this.feedPubDate+'<br />': '',
				'Logo'             : logo,
				'INC-Items'        : items,
				'RSSId'            : this._readerid,
				'RefreshFeed'      : this.translation.get('RefreshFeed')
			}
		});
		 var output = templateProcessor.generateOutput();
		 return output;
	},
	createStandard: function(){
		var logo = '';
		if(this.showlogo == "on" && this.logosrc != ''){
			logo = '<a href="'+this.logolink+'" target="_blank"><img src="'+this.logosrc+'" /></a>';
		}
		var items = '';
		for( var i=0,iLength=this.length ; i<iLength ; i++ ){
			var text = this.news[i]["text"];
			if(this.textlength > 1){
          text = text.substr(0,this.textlength);
          var lastspace = text.lastIndexOf(" ");
          text = text.substr(0,lastspace);
          text += "...";
        }
        else if(this.textlength == 0){
        	text = "";
        }
        if(this.stripimages == "on"){
        	text = text.replace(/\<img.*?\>/gi,"");
        }
      var pubDate = this.news[i]["pubDate"] != '' &&  this.textlength != 0 ? this.news[i]["pubDate"]+'<br />': '';
			var templateProcessorItems = new epages.Template({
				template    : this.classicItemTemplateString,
				encodeVars  : false,
				vars        : {
					'URL'            : this.news[i]["link"],
					'Title'          : this.news[i]["title"],
					'Text'           : text,
					'PubDate'        : pubDate
				}
			});
			items += templateProcessorItems.generateOutput();
		}
		var templateProcessor = new epages.Template({
			template    : this.classicTemplateString,
			encodeVars  : false,
			vars        : {
				'RSSIcon'          : this.icon,
				'FeedLink'         : this.pagelink,
				'FeedName'         : this.feedname,
				'FeedDescription'  : this.feeddescription,
				'FeedPubDate'      : this.feedPubDate != '' ? this.feedPubDate+'<br />': '',
				'Logo'             : logo,
				'INC-Items'        : items,
				'RSSId'            : this._readerid,
				'RefreshFeed'      : this.translation.get('RefreshFeed')
			}
		});
		 var output = templateProcessor.generateOutput();
		 return output;
	},
	contentString: function (info, ispreview) {
		if(ispreview){
			if(info.formData.get('RSSReaderFeedUrl')){
				if(this.isindividual){
					var feedurl = encodeURIComponent(info.formData.get('RSSReaderFeedUrl')[0]);
				}
				else{
					var feedurl = info.formData.get('RSSReaderFeedUrl')[0];
				}
				this.getData(feedurl,this.lengthrequest);
				var returnstring = '<link href="'+epages.vars.StoreRoot+'/SF/Gadgets/RSSFeedClassic.css" rel="stylesheet" type="text/css" /><link href="'+epages.vars.StorefrontStyleCss+'" rel="stylesheet" type="text/css" />';
				returnstring += this.showData(info.formData.get('RSSReaderSelectStyle')[0],info.formData.get('RSSReaderEntrys')[0],info.formData.get('RSSReaderLengthEntrys')[0],info.formData.get('RSSReaderShowLogo')[0],info.formData.get('RSSReaderStripImages')[0],info.formData.get('RSSReaderOnlyHeadlines')[0]);
				return returnstring;
			}
			else{
				return "";
			}
		}
		else{
			if(this.isindividual){
				var feedurl = encodeURIComponent(info.formData.get('RSSReaderFeedUrl')[0]);
			}
			else{
				var feedurl = info.formData.get('RSSReaderFeedUrl')[0];
			}
			var timestamp = new Date();
			var finalstring = [
				'<link href="'+epages.vars.StoreRoot+'/SF/Gadgets/RSSFeedClassic.css" rel="stylesheet" type="text/css" />',
				'<script type="text/javascript" language="Javascript">',
				'if(RSSReader == undefined) var RSSReader = {};',
				'dojo.addOnLoad(function () {',
				'if(document.getElementById("RSSFeed'+timestamp.getTime()+'")){',
				'dojo["require"]("epages.cartridges.de_epages.externalcontent.rssreader");',
				'RSSReader['+timestamp.getTime()+'] = new epages.cartridges.de_epages.externalcontent.RSSReader();',
				'RSSReader['+timestamp.getTime()+'].getData("'+feedurl+'",'+this.lengthrequest+');',
				'document.getElementById("RSSFeed'+timestamp.getTime()+'").innerHTML = RSSReader['+timestamp.getTime()+'].showData("'+info.formData.get('RSSReaderSelectStyle')[0]+'",'+info.formData.get('RSSReaderEntrys')[0]+','+info.formData.get('RSSReaderLengthEntrys')[0]+',"'+info.formData.get('RSSReaderShowLogo')[0]+'","'+info.formData.get('RSSReaderStripImages')[0]+'","'+info.formData.get('RSSReaderOnlyHeadlines')[0]+'","'+timestamp.getTime()+'");',
				'}});',
				'</script>',
				'<div id="RSSFeed'+timestamp.getTime()+'"></div>'
			].join("\n");
			return finalstring;
		}
	},
	refresh: function(){
		this.secondRequest();
		if(this.error == false){
			this.readResponse();
		}
		else{
			return false;
		}
		document.getElementById('RSSFeed'+this._readerid).innerHTML = this.showData(this.style,this.length,this.textlength,this.showlogo,this.stripimages,this.onlyheadlines,this._readerid);
	}
});