# Usage example:
#
#   nmake -f ../Installer/Scripts/Installer.mak \
#		CARTRIDGES=$(COMPANY)::$(CARTRIDGE) STORE=Site PERL=$(PERL) test
#
PERL = perl
CARTRIDGES =
STORE =
RECURSIVE =
# -recursive
#FORCE=-force
DE_EPAGES = ../../DE_EPAGES
CVS_CARTRIDGESPATH = RND/epages/epages5/AllOS/Cartridges

INSTALL	    = $(PERL) $(DE_EPAGES)/Installer/Scripts/install.pl $(FORCE)
UNINSTALL   = $(PERL) $(DE_EPAGES)/Installer/Scripts/uninstall.pl
PATCH	    = $(PERL) $(DE_EPAGES)/Installer/Scripts/patch.pl
CREATEPATCH = $(PERL) $(DE_EPAGES)/Installer/Scripts/buildCartridgePatch.pl
CREATEPATCH_OBSOLETE = $(PERL) $(DE_EPAGES)/Installer/Scripts/create_patch.pl
BUILDPATCH  = $(PERL) $(DE_EPAGES)/Installer/Scripts/build_patch.pl
INSTALLCPAN = $(PERL) $(DE_EPAGES)/Installer/Scripts/installCPAN.pl

install:
	$(INSTALL) $(RECURSIVE) -storename "$(STORE)" $(CARTRIDGES)

uninstall:
	$(UNINSTALL) $(FORCE) $(RECURSIVE) -storename "$(STORE)" $(CARTRIDGES)

create_patch:
	$(CREATEPATCH) -oldrelease $(OLDRELEASE) -newrelease $(NEWRELEASE) -subversionpath $(CVS_CARTRIDGESPATH) -cartridge $(CARTRIDGES)

create_patch_obsolete:
	$(CREATEPATCH_OBSOLETE) -lastrelease $(OLDRELEASE) -release $(NEWRELEASE) -cvspath $(CVS_CARTRIDGESPATH) $(CARTRIDGES)

build_patch:
	$(BUILDPATCH) -oldrelease $(OLDRELEASE) -newrelease $(NEWRELEASE) -cvspath $(CVS_CARTRIDGESPATH)

test_patch_all_sites:
	$(PATCH) -test -site $(CARTRIDGES)

patch_all_sites:
	$(PATCH) $(FORCE) -site $(CARTRIDGES)

test_patch:
	$(PATCH) -test -storename "$(STORE)" $(CARTRIDGES)

patch:
	$(PATCH) $(FORCE) -storename "$(STORE)" $(CARTRIDGES)

cpan:
	$(INSTALLCPAN) $(CARTRIDGES)
