jQuery.plugin('de_epages.presentation.inc.batchactions', {
  plugin: ['ep.fn.holdOnTop', 'jQuery.storage', 'jQuery.scope', 'de_epages.core'],
  DOM: true
}, function($,undefined){

	var fnBatchActionStack = $.scope('de_epages.presentation.inc.batchactions').stack = [];

  var $firstContentList = $('.ContentList:visible:first');
  if(!$firstContentList.length){
    $firstContentList = $('.ContentList:first');
  }
  var selectedCheckboxes = jQuery.sessionStorage('ep_selectedCheckboxes');
  /* If sessionStorage contains info about selected Checkboxes,
  then select the corresponding table rows and do a highlighting effect */
  if (selectedCheckboxes){
    $(selectedCheckboxes).each(function(){
      var selectedTableRows = $firstContentList.find('input[value='+$(this).attr('value')+']').closest('tr');
      selectedTableRows.addClass('HideSelectedRefresh');
      // set Timeout-functions, necessary for animation (see "table.ContentList tbody tr.ShowSelectedRefresh td span" @ BackofficeStyle.css)
      setTimeout(function(){
        selectedTableRows.addClass('ShowSelectedRefresh');
      }, 1);
      // necessary to remove css class when animation has ended
      setTimeout(function(){
        selectedTableRows.removeClass('ShowSelectedRefresh').removeClass('HideSelectedRefresh');
      }, 2500);
    });
    /* Clear sessionStorage again */
    jQuery.sessionStorageClear('ep_selectedCheckboxes');
  }

  $('.BatchActions > li')
  /* initialze BatchAction menu */
    .each(function( i ){
      var elem = $(this),
        label = elem.children('label'),
        items = elem.find('li');
      if( items.length <= 1 ){
        var textElem  = items.find('> label > div:first'),
          text    = $.trim( textElem.text() );

        if( text.length > 25 ){
          textElem.attr('title',text).text( ep.scrunch(text, 25) );
        }

        label.children('input')
          .before( items.find('input') )
          .remove();
        label.find('> div:last')
          .before( textElem )
          .remove();
        items.parent().remove();
      }
      else{
        label.children('input')
          .before( items.find('input').clone(true) );
        items.parent()
          .hover(
            function(){
              label.children('input').addClass('active');
            },
            function(){
              label.children('input').removeClass('active');
            }
          );

        label.find('> div:first')
          .addClass('ep-batchActions-hasMenu');

        label.find('> div:last')
          .append('<br />&#9660;')
          .addClass('ep-batchActions-hasMenu')
          .on('click', function(evt){
            evt.preventDefault();
            evt.stopPropagation();
            var elem = $(this);
            if(!elem.parents('label').hasClass('BatchActionDisabled')){
              elem.parents('li').toggleClass('showMenu');
            }
          });

        $('body').on('click',function(){
          $('.showMenu').removeClass('showMenu');
        });

        elem.hTimer = undefined;
        elem.hover(
          function(evt){
            // clear timeout if mouse enters menue again
            if(elem.hTimer !== undefined){
              window.clearTimeout(elem.hTimer);
              elem.hTimer = undefined;
            }
          },
          function(){
            var $this = $(this);
            // close menue with delay
            elem.hTimer = window.setTimeout(function(){
              //remove 'showMenu' if unhover event for whole li is called
              $this.removeClass('showMenu');
            }, 500);
          }
        );
      }
    })
  /* bind BatchAction events */
    .find('input:radio')
      .on('change',function( event ){
        var elem = $(this),
            scriptAction = elem.data('scriptAction');

        if (elem.parent().hasClass('BatchActionDisabled')){
          return;
        }

        var inputValue = elem.attr('value');
  // 'SetInvisibleListedObjects' used only for Categories-section
  // If the currently marked row is set visible, then set it invisible.
  // detect if the row is visible via class which ist set to the icon or image
        if (inputValue.match(/Set.*(?!Not)Visible/g) || inputValue === 'SetInvisibleListedObjects'){
          if (!$firstContentList.find('tr.RowSelected i[class*=_inactive]:first,tr.RowSelected img[class*=imgOff]:first,tr.RowSelected img[src*=_inactive]:first').length){
            elem.attr('value', elem.next().attr('value'));
          }
        }

        if (inputValue === 'SetProductsNew'){
          var mixedSelection = 0;
          $firstContentList.find('tbody tr.RowSelected')
            // If rows with AND rows without "new"-icons are checked,
            // then give all these rows an icon.
            .each(function(index){
              if (!$(this).find('table.InnerListTable td.BreakLink + td i').length && $(this).find('i[class*=list_ico_s_variationproducts]:first').length==0){
                mixedSelection = 1;
              }
            });
          // But if all checked rows got such an icon, then delete their "new"-icons
          if (mixedSelection === 0){
            elem.attr('value', elem.next().attr('value'));
          }
        }

        toggleDefaultChangeAction( this.form, true );

        if( scriptAction ){
        	//try to avoid error
          try{
          	//used to exectue batch action saved in variable
            eval( '('+scriptAction+').call(this,arguments[0]);' );
          }
          catch( error ){
            toggleDefaultChangeAction( this.form, false );
            $.error( error );
          }
        }
        else{
          /* Filtering the selected items (Variations products can't be set to new) */
          var selectedCheckboxes = $firstContentList.find('input[name=ListObjectID]:checked');
          var filteredSelections = [];

          if (inputValue === 'SetProductsNew' || inputValue === 'SetProductsNotNew'){
            selectedCheckboxes.each(function(){
              if (!$(this).closest('tr').find('a[href*="ViewAction=MBO-ViewVariations"]').length){
                filteredSelections.push(this);
              }
            });
          }else{
            filteredSelections = selectedCheckboxes;
          }
          jQuery.sessionStorage('ep_selectedCheckboxes', $(filteredSelections).serializeArray());
          $(this.form).trigger('submit');
        }
      });

  var toggleDefaultChangeAction = function( form, isDisabled ){
    $(form.elements)
      .filter('[name=ChangeAction][type=hidden]')
      .prop('disabled',isDisabled);
  };

  /* show BatchActionBar always on top */
   ep('.BatchActionsBar').holdOnTop('top');

  // Activate/Deactivate BatchAction buttons
  var toggleBatchActionAvailability = function(){
    var contentList = this;

    // ContentList widget natively delays checkbox setting
    setTimeout(function(){
      var dynamicButtons = $('.EnableTableSelection');
      var activeRows = $(contentList).find('tbody tr td:first-child input[type=checkbox]:checked').closest('tr');
      if (activeRows.length){
        dynamicButtons.removeClass('BatchActionDisabled');
        dynamicButtons.find('input').removeAttr('disabled');
        dynamicButtons.find('img').each(function(){
          $(this).attr('src', $(this).data('originalSrc'));
        });
      } else {
        dynamicButtons.addClass('BatchActionDisabled');
        dynamicButtons.find('input').attr('disabled', 'true');
        dynamicButtons.find('img').each(function(){
          $(this).attr('src', $(this).data('greySrc'));
        });
      }
      //set Visibility and Mark active
      if(activeRows.length){
        if(!activeRows.find('i[class*=_inactive]:first,img[class*=imgOff]:first, img[src*=_inactive]:first').length){
          $('.ep-batchActions-groupImage-View').parent().addClass('ep-batchActions-groupImage-active');
        }
        else{
          $('.ep-batchActions-groupImage-View').parent().removeClass('ep-batchActions-groupImage-active');
        }

        var rowCount = activeRows.length,
            rowsMarkedNew = activeRows.find('i[class*=ico_s_isnew]:first').length;

        if(rowCount === rowsMarkedNew){
          $('.ep-batchActions-groupImage-Mark').parent().addClass('ep-batchActions-groupImage-active');
        }
        else{
          $('.ep-batchActions-groupImage-Mark').parent().removeClass('ep-batchActions-groupImage-active');
        }
      }

      if(fnBatchActionStack.length){
        for(var key in fnBatchActionStack){
          fnBatchActionStack[key]();
        }
      }
    }, 1);

  };

  // select rows if checkbox is checked on start up
  $('.ContentList tbody tr td:first-child input[type=checkbox]:checked')
    .closest('tr')
    .addClass('RowSelected');

  $firstContentList.on('mouseup', toggleBatchActionAvailability);
  $firstContentList.on('keyup', toggleBatchActionAvailability);
  toggleBatchActionAvailability.call($firstContentList);

    /* initialize NewEntry table row */
  var line  = $('tr.NewEntry');

  // if a row for a new entry exists
  if(line.length){
    var inputs  = line.find('input:visible'),
        addSave = line.find('.Checkbox > .PlusIcon'),
        submit = $(inputs[0].form.elements).filter('input[type=submit]'),
        setAdd  = function( event ){
          inputs.first().trigger('focus');
        },
        setSave = function(){
          inputs  = $('tr.NewEntry').find('input:visible');
          if( inputs.length ){
            //check and clear epages.widget.ButtonChangeForms to avoid leave page warning on submit
            if( epages.widget.ButtonChangeForms && epages.widget.ButtonChangeForms.length ){
              epages.widget.ButtonChangeForms = [];
            }
            $( inputs[0].form ).trigger({type:'submit',dojoconnect:true});
          }
        },
        onFocus = function( event ){
          if( !submit.length ){
            submit = $('<input type="submit" class="HideElementSoft" />').insertAfter( addSave );
          }
          inputs
            .off('focus',onFocus);
          addSave
            .off()
            .on('click',setSave)
            .toggleClass('ico_s_add', false)
            .toggleClass('ico_s_save', true);
        };

    addSave.on('click',setAdd);
    line.on('focus','input',onFocus);
  }
});